moBunkerSilos = {};
source(MultiOverlayV3.modDir.."scripte/module/bunkersilos/moBunkerSilosConfig.lua");

function moBunkerSilos:update(dt)
	if moModule.active.bunkersilos.isRunning then
		if moBunkerSilos.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateBunkerSilos"] ~= nil then return;end;
			moSetGetExtras:addTimer( {delay=moBunkerSilos.values.updateTimer, name="updateBunkerSilos", ms=moBunkerSilos.values.msec, repeatable=1, action=moBunkerSilos.load} )
		else
			moBunkerSilos:load();
		end;
	end;
end;

function moBunkerSilos:load()	
	moBunkerSilos:loadBunkerSilos();
end;

function moBunkerSilos:loadBunkerSilos()	
	local playerFarmId = g_currentMission.player.farmId;	
	moBunkerSilos.values.bunkersilos ={}; --new
	if moModule.bunkerSilos ~= nil and #moModule.bunkerSilos > 0 then
		local deleteObject = {};
		for index=1, #moModule.bunkerSilos do			
			if moModule.bunkerSilos[index] ~= nil then
				local isObject = moModule:isObject(moModule.bunkerSilos[index].object);
				if isObject then
					local bunkersilo = moModule.bunkerSilos[index].object;
					if bunkersilo.ownerFarmId == 0 or bunkersilo.ownerFarmId == playerFarmId then
						local bunkersiloName = moModule.bunkerSilos[index].xmlName;
						if moBunkerSilos.values.bunkersilos[bunkersiloName] == nil then moBunkerSilos.values.bunkersilos[bunkersiloName] = {};end;
						moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]+1] = {general={},output={},input={},bunkerSilos={}};
						local lineTableGeneral = moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]].general;
						lineTableGeneral[#lineTableGeneral+1] = {};
						local isLineTableGeneral = lineTableGeneral[#lineTableGeneral];						
						isLineTableGeneral.object = bunkersilo;
						isLineTableGeneral.objectName = moModule.bunkerSilos[index].name;
						isLineTableGeneral.xmlName = bunkersiloName;
						if bunkersilo.bunkerSilos ~= nil and #bunkersilo.bunkerSilos > 0 then							
							for bunkerIndex=1, #bunkersilo.bunkerSilos do
								if bunkersilo.bunkerSilos[bunkerIndex] ~= nil then									
									
									moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]].bunkerSilos[#moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]].bunkerSilos+1] = {general={},output={},input={}};
									lineTableGeneral = moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]].bunkerSilos[#moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]].bunkerSilos].general;	
									lineTableGeneral[#lineTableGeneral+1] = {};									
									isLineTableGeneral = lineTableGeneral[#lineTableGeneral];
									isLineTableGeneral.object = bunkersilo.bunkerSilos[bunkerIndex];
									isLineTableGeneral.objectName = moLanguageXml:getTxt("bunkersilo", nil, "BunkerSilo").. " ".. tostring(bunkerIndex);
									isLineTableGeneral.compactedFillLevel = g_i18n:formatNumber(bunkersilo.bunkerSilos[bunkerIndex].compactedFillLevel);
									isLineTableGeneral.compactedPercent = bunkersilo.bunkerSilos[bunkerIndex].compactedPercent;										
									isLineTableGeneral.fermentingPercent = "-";
									isLineTableGeneral.fermentingColor = nil;
									if bunkersilo.bunkerSilos[bunkerIndex].state == BunkerSilo.STATE_CLOSED then
										isLineTableGeneral.fermentingPercent = Utils.getNoNil(bunkersilo.bunkerSilos[bunkerIndex].fermentingPercent, 0);
										isLineTableGeneral.fermentingColor = MultiOverlayV3:get_hl("getProzentColor", {Utils.getNoNil(bunkersilo.bunkerSilos[bunkerIndex].fermentingPercent, 0), true}, "getProzentColor BunkerSilos Fermenting ".. tostring(bunkerIndex))
									end;
									if bunkersilo.bunkerSilos[bunkerIndex].state == BunkerSilo.STATE_FERMENTED then
										isLineTableGeneral.compactedFillLevel = "-";
									end;
									--state = BunkerSilo.STATE_CLOSED, BunkerSilo.STATE_FERMENTED, BunkerSilo.STATE_DRAIN									
									--
									local lineTableOutput = moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]].bunkerSilos[#moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]].bunkerSilos].output;
									lineTableOutput[#lineTableOutput+1] = {};						
									isLineTableOutput = lineTableOutput[#lineTableOutput];									
									local capacity, fillLevel, fillTypesTotal = 0, bunkersilo.bunkerSilos[bunkerIndex].fillLevel, {};									
									local fillType = moFillTypes.values.fillTypes[bunkersilo.bunkerSilos[bunkerIndex].outputFillType];
									if fillType ~= nil then
										isLineTableOutput.fillTypeName = fillType.name;
									else
										isLineTableOutput.fillTypeName = moLanguageXml:getTxt("unknown", nil, "Unknown");
									end;										
									isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
									if Utils.getNoNil(fillLevel, 0) <= 0 then
										isLineTableOutput.fillTypeName = "Out (".. moLanguageXml:getTxt("unknown", nil, "Unknown").. ")";
									end;
									if bunkersilo.bunkerSilos[bunkerIndex].state ~= BunkerSilo.STATE_DRAIN then	
										isLineTableOutput.fillLevel = "-";
									end;										 
									isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
									isLineTableOutput.percentageCapacity = math.floor(100 * (fillLevel/capacity));									
									---									
									local lineTableInput = moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]].bunkerSilos[#moBunkerSilos.values.bunkersilos[bunkersiloName][#moBunkerSilos.values.bunkersilos[bunkersiloName]].bunkerSilos].input;
									lineTableInput[#lineTableInput+1] = {};						
									isLineTableInput = lineTableInput[#lineTableInput];
									fillTypesTotal = moBunkerSilos:getAcceptedFillTypes(bunkersilo.bunkerSilos[bunkerIndex].acceptedFillTypes);
									local fillTypes = moFillTypes.values.fillTypes[fillTypesTotal[1]];
									if fillTypes ~= nil then
										isLineTableInput.fillTypeName = fillTypes.name;
									else
										isLineTableInput.fillTypeName = moLanguageXml:getTxt("bunkerfilllevel", nil, "FillLevel");
									end;										
									isLineTableInput.fillTypesTotal = fillTypesTotal;
									isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
									if bunkersilo.bunkerSilos[bunkerIndex].state == BunkerSilo.STATE_DRAIN then
										isLineTableInput.fillLevel = "-"
									end;
									isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
									isLineTableInput.percentageCapacity = math.floor(100 * (fillLevel/capacity));
									---
								end;
							end;
						end;
					end;
				else
					table.insert(deleteObject, index);				
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.bunkerSilos, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;	
end;

function moBunkerSilos:getAcceptedFillTypes(fillTypeModule)
	local fillTypesTotal = {};
	for index, isAccepted in pairs(fillTypeModule) do
		if isAccepted then
			table.insert(fillTypesTotal, index);
		end;
	end;
	return fillTypesTotal;
end;