fillTypesEnableDisable = {};

--needs module fillTypes
function fillTypesEnableDisable:load()
	if moFillTypes == nil or moFillTypes.values == nil or moFillTypes.values.fillTypes == nil then fillTypesEnableDisable.output = {};return;end;
	--local lineTable = {lineTyp=1, onSaveCallback=fillTypesEnableDisable.onSaveCallback, txtScroll={leftRight=true,upDown=true}};
	local lineTable = {lineTyp=1, txtScroll={leftRight=true,upDown=true}};
	lineTable[#lineTable+1] = {};
	local isLineTable = lineTable[#lineTable];				
	isLineTable.lineClickIcon = true;
	isLineTable.lineClickIconCallback = fillTypesEnableDisable.returnClickIconViewNameRegNameIndex;
	isLineTable.txt = {};	
	isLineTable.txt[1] = {width=96, color=moColors:getColor(moModule.values.txtTitleColor), txt="Enabled FillTypes (click name)", bold=true};
	for a=1, #moFillTypes.values.fillTypes do
		if moFillTypes.values.fillTypes[a] ~= nil and moFillTypes.values.fillTypes[a].view then
			local fillTypes = moFillTypes.values.fillTypes[a]
			lineTable[#lineTable+1] = {};
			isLineTable = lineTable[#lineTable];				
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].width = 96; --prozent width
			isLineTable.txt[1].index = fillTypes.index; --own value
			isLineTable.txt[1].color = moColors:getColor(moModule.values.txtFillTypesColor);
			isLineTable.txt[1].bold = moModule.values.txtBold;
			--isLineTable.txt[1].difSize = 0.001;
			isLineTable.txt[1].clickCallback = fillTypesEnableDisable.returnClickDisableFillTypes;				
			local name = "";
			if moFillTypes.values.name then name = fillTypes.name;end;
			if moFillTypes.values.regName then
				if string.len(name) == 0 then name = fillTypes.regName;else name = name.. " (".. fillTypes.regName.. ")";end;
			end;
			if moFillTypes.values.index then
				if string.len(name) == 0 then name = fillTypes.index;else name = name.. " *".. fillTypes.index.. "*";end;
			end;
			isLineTable.txt[1].txt = tostring(name);			
		end;
	end;
			
	lineTable[#lineTable+1] = {};
	isLineTable = lineTable[#lineTable];				
	isLineTable.lineBorder = {1, 0.001, true, false, false, false, moColors.intern["darkGray"]};
	isLineTable.txt = {};
	isLineTable.txt[1] = {width=96, color=moColors:getColor(moModule.values.txtTitleColor), txt="Disabled FillTypes (click name)", bold=true};
	for a=1, #moFillTypes.values.fillTypes do
		if moFillTypes.values.fillTypes[a] ~= nil and not moFillTypes.values.fillTypes[a].view then
			local fillTypes = moFillTypes.values.fillTypes[a]
			lineTable[#lineTable+1] = {};
			isLineTable = lineTable[#lineTable];				
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].width = 96; --prozent width
			isLineTable.txt[1].index = fillTypes.index; --own value
			isLineTable.txt[1].color = moColors:getColor(moModule.values.txtFillTypesColor);
			isLineTable.txt[1].bold = moModule.values.txtBold;
			--isLineTable.txt[1].difSize = 0.001;
			isLineTable.txt[1].clickCallback = fillTypesEnableDisable.returnClickEnableFillTypes;				
			local name = "";
			if moFillTypes.values.name then name = fillTypes.name;end;
			if moFillTypes.values.regName then
				if string.len(name) == 0 then name = fillTypes.regName;else name = name.. " (".. fillTypes.regName.. ")";end;
			end;
			if moFillTypes.values.index then
				if string.len(name) == 0 then name = fillTypes.index;else name = name.. " *".. fillTypes.index.. "*";end;
			end;
			isLineTable.txt[1].txt = tostring(name);
		end;
	end;
	fillTypesEnableDisable.output = lineTable;	
end;

function fillTypesEnableDisable.returnClickIconViewNameRegNameIndex(...)	
	if ... ~= nil then		
		local args = ...;		
		local name=moFillTypes.values.name; local regName=moFillTypes.values.regName; local index=moFillTypes.values.index;
		if name and regName and index then regName = false; index = false;
		elseif name and regName and not index then index = true;
		elseif name and not regName and not index then regName = true;end;		
		moFillTypes.values.name = name; moFillTypes.values.regName = regName; moFillTypes.values.index = index;
		fillTypesEnableDisable:reset(args.whereClick);		
	end;
end;

function fillTypesEnableDisable.returnClickEnableFillTypes(...)
	if moFillTypes == nil or moFillTypes.values == nil or moFillTypes.values.fillTypes == nil then return;end;
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			local index = fillTypesEnableDisable.output[args.line].txt[1].index;
			if moFillTypes.values.fillTypes[index] ~= nil then
				if moFillTypes.values.fillTypes[index].view then return;end;
				moFillTypes.values.fillTypes[index].view = true;
				fillTypesEnableDisable:reset(args.whereClick);
			end;			
		end;
	end;	
end;

function fillTypesEnableDisable.returnClickDisableFillTypes(...)
	if moFillTypes == nil or moFillTypes.values == nil or moFillTypes.values.fillTypes == nil then return;end;
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil then
			if args.line ~= nil then
				local index = fillTypesEnableDisable.output[args.line].txt[1].index;
				if moFillTypes.values.fillTypes[index] ~= nil then
					if not moFillTypes.values.fillTypes[index].view then return;end;
					moFillTypes.values.fillTypes[index].view = false;
					fillTypesEnableDisable:reset(args.whereClick);
				end;
			end;
		end;
	end;
end;

function fillTypesEnableDisable.giveOutputTable()	
	moModule.active.fillTypes.isRunning = true;moModule.active.fillTypes.last = moModule.time.min+moModule.time.delay;
	if fillTypesEnableDisable.output == nil then fillTypesEnableDisable:reset();end;
	return fillTypesEnableDisable.output;	
end;

function fillTypesEnableDisable:reset(whichSLOT)	
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	fillTypesEnableDisable:load();		
end;