sellingStationsSimple = {};

--needs module sellingStationsSimple,greatDemand
--lineType 1/sellingStations simple
function sellingStationsSimple:load()
	local lineTable = {lineTyp=1, txtScroll={leftRight=true,upDown=true}};
	lineTable[#lineTable+1] = {};
	local isLineTable = lineTable[#lineTable];				
	isLineTable.lineClickHelp = true;
	isLineTable.lineClickHelpCallback = sellingStationsSimple.returnLineHelpIconClick
	isLineTable.helpTxt = "Click StationName for MapHotSpot";
	isLineTable.txt = {};
	isLineTable.txt[1] = {color=moColors:getColor(moModule.values.txtColor), txt=moLanguageXml:getTxt("sellingstations", nil, "Stations:"), bold=true};	
	local deleteObject = {}; --over moSellingStations
	for index=1, #moModule.sellingStations do		
		if moModule.sellingStations[index] ~= nil then
			lineTable[#lineTable+1] = {};
			isLineTable = lineTable[#lineTable];			
			isLineTable.txt = {};
			isLineTable.txt[1] = {};					
			if moModule:isObject(moModule.sellingStations[index].object) then
				isLineTable.txt[1].clickCallback = sellingStationsSimple.returnClickObjectName;
			end;
			isLineTable.txt[1].nodeId = moModule.sellingStations[index].object.nodeId;			
			isLineTable.txt[1].bold = moModule.values.txtBold;
			--isLineTable.txt[1].difSize = 0.001;
			local name = moModule.sellingStations[index].name;
			if moGreatDemand.values.stations[name] ~= nil then 
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtGreatDemandColor);
			else
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
			end;
			local languageXmlName = moLanguageXml:getTxt(string.lower(name), nil, name);
			if moSellingStations.values.languageXml and not string.find(languageXmlName, "MISSING") then name = languageXmlName;end;
			isLineTable.txt[1].txt = tostring(name);
		end;
	end;	
	sellingStationsSimple.output = lineTable;	
end;

function sellingStationsSimple.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			--moSetGetOverlays.infoHelpBox.help.txtColor = moColors:getColor(moSetGetOverlays.infoHelpBox.help.defaultColor);
			moSetGetOverlays.infoHelpBox.help.txt = tostring(sellingStationsSimple.output[args.line].helpTxt);
		end;
	end;
end;

function sellingStationsSimple.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil then
			local nodeId = sellingStationsSimple.output[args.line].txt[1].nodeId;
			local x, _, z = getWorldTranslation(nodeId);			
			moSetGetOverlays:mapHotSpot(nil, x, z);			
		end;		
	end;
end;

function sellingStationsSimple.giveOutputTable()	
	moModule.active.sellingStationsSimple.isRunning = true;moModule.active.sellingStationsSimple.last = moModule.time.min+moModule.time.delay;
	moModule.active.greatDemand.isRunning = true;moModule.active.greatDemand.last = moModule.time.min+moModule.time.delay;
	sellingStationsSimple:load();
	return sellingStationsSimple.output;	
end;

function sellingStationsSimple:reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	sellingStationsSimple:load();	
end;

function sellingStationsSimple:generateCmd()
	local _, errorTable = 0, {};
	local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
	newCmdTable.cmdTable[1] = {
		cmdName = "sellingStationsSimple";
		displayName = "Alle Verkaufstationen Simple";		
		multiple = true;
		sortBy = "SellingStations";
		infoTxt = "Zeigt all Verkaufstationen an(simple)";
		helpTxt = "View Selling Stations (simple)";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
		lineTyp = 1;
		typ = "output";
		action = sellingStationsSimple.giveOutputTable; --a function
		ownValues = {}; 
	};	
	_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	local errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->cmd generate moSellingStations Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;
end;